module TestAbstractions
  class Context
    include Initializer

    initializer :base_uri, :driver

    def self.instance
      @instance ||= build
    end

    def self.build(configuration: nil, driver: nil)
      configuration ||= Configuration.instance

      base_uri = configuration.base_uri

      driver_name = configuration.driver_name

      driver = Session.build driver_name

      instance = new base_uri, driver
      instance
    end
  end
end
